# Intelligent Computing Systems

## Course Overview

- University: University of Chinese Academy of Sciences
- Prerequisites: Computer Architecture, Deep Learning
- Programming Languages: Python, C++, BCL
- Course Difficulty: 🌟🌟🌟
- Estimated Hours: 100+ hours

Intelligent computing systems serve as the backbone for global AI, producing billions of devices annually, including smartphones, servers, and wearables. Training professionals for these systems is critical for China's AI industry competitiveness. Understanding intelligent computing systems is vital for computer science students, shaping their core skills.

Prof. Yunji Chen's course, taught in various universities, uses experiments to provide a holistic view of the AI tech stack. Covering deep learning frameworks, coding in low-level languages, and hardware design, the course fosters a systematic approach.

Personally, completing experiments 2-5 enhanced my grasp of deep learning frameworks. The BCL language experiment in chapter five is reminiscent of CUDA for those familiar.

I recommend the textbook for a comprehensive tech stack understanding. Deep learning-savvy students can start from chapter five to delve into deep learning framework internals.

Inspired by the course, I developed a [simple deep learning framework](https://github.com/ysj1173886760/PyToy) and plan a tutorial. Written in Python, it's code-light, suitable for students with some foundation. Future plans include more operators and potential porting to C++ for balanced performance and efficiency.

## Course Resources

- Course Website：[Official Website](https://novel.ict.ac.cn/aics/)
- Course Videos：[bilibili](https://space.bilibili.com/494117284)
- Course Textbook："Intelligent Computing Systems" by Chen Yunji
- Course Assignments：6 experiments (including writing a convolutional operator, adding operators to TensorFlow, writing operators in BCL and integrating them into TensorFlow, etc.) (specific content can be found on the official website)
- Experiment Manual：[Experiment 2.0 Guide Manual](https://forum.cambricon.com/index.php?m=content&c=index&a=show&catid=155&id=708)
- Study Notes：<https://sanzo.top/categories/AI-Computing-Systems/>, notes summarized based on the experiment manual

## Resource Compilation

All resources and homework implementations used by @ysj1173886760 in this course are consolidated in [ysj1173886760/Learning: ai-system - GitHub](https://github.com/ysj1173886760/Learning/tree/master/ai-system)
